package com.example.aped.ui.visualization;

import android.content.Intent;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.TextView;
import com.android.volley.Response;
import com.example.aped.MainActivity;
import com.example.aped.R;
import com.example.aped.ui.visualization.PinView;

import org.json.JSONException;
import org.json.JSONObject;
import java.util.ArrayList;
import java.util.List;


public class MainListViewAdapter extends BaseAdapter {

    private MainActivity mainActivity;

    private int favoriteMode;

    private String deviceName;

    private int image;

    private int favoriteImage;

    public MainListViewAdapter(MainActivity pMainActivity,int pFavoriteMode){
        this.mainActivity = pMainActivity;
        this.favoriteMode = pFavoriteMode;
        /**
         * pFavoriteMode 0 oder 1 möglich
         * 1 für wir befinden uns in Anzeige favorite IOs
         * 0 für wir befinden uns in Anzeige all IOs
         */
    }


    @Override
    public int getCount() {
        int devices;
        if (favoriteMode == 0){
            devices = mainActivity.xml.getDeviceNames().size();
        }else{
            devices = mainActivity.favorite.getFavorites().size();
        }
        return devices;
    }

    @Override
    public Object getItem(final int position) {

        return null;
    }

    @Override
    public long getItemId(final int position) {

        return 0;
    }

    @Override
    public View getView(final int i, View view,
                        final ViewGroup viewGroup) {
        view = mainActivity.getLayoutInflater().inflate(R.layout.listview_layout,
                null);
        TextView textViewName = (TextView) view.findViewById(
                R.id.textName);
        LinearLayout linearLayoutPin = (LinearLayout) view.findViewById(
                R.id.idLinearLayoutPins);
        ImageView buttonViewFavoriten = (ImageView) view.findViewById(
                R.id.imageButtonFavoriten);
        if (favoriteMode == 0){
            deviceName = mainActivity.xml.getDeviceNames().get(i);
        }else{
            deviceName = mainActivity.favorite.getFavorites().get(i);
        }

        if (mainActivity.favorite.getFavorites().contains(
                deviceName)) {
            favoriteImage = android.R.drawable.btn_star_big_on;
        } else {
            favoriteImage = android.R.drawable.btn_star_big_off;
        }

        buttonViewFavoriten.setOnClickListener(
                new View.OnClickListener() {
                    @Override
                    public void onClick(final View view) {
                        if (favoriteMode == 0){
                            deviceName = mainActivity.xml.getDeviceNames().get(i);
                        }else{
                            deviceName = mainActivity.favorite.getFavorites().get(i);
                        }
                        if (mainActivity.favorite.getFavorites().contains(
                                deviceName)) {
                            mainActivity.favorite.removeFavorite(
                                    deviceName);
                            favoriteImage = android.R.drawable.btn_star_big_off;
                            buttonViewFavoriten.setImageResource(
                                    favoriteImage);
                        } else {
                            mainActivity.favorite.addFavorite(
                                    deviceName);
                            favoriteImage = android.R.drawable.btn_star_big_on;
                            buttonViewFavoriten.setImageResource(
                                    favoriteImage);
                        }
                        Intent intentneustart = mainActivity.getIntent();//                 gegen richtigen Befehl tauschen da nur die visualisierung neu gestartet werden soll
                        mainActivity.finish();
                        mainActivity.startActivity(intentneustart);
                    }
                });
        //textViewPin.setText(((List<String>) (mainActivity.xml.getPort(mainActivity.xml.getDeviceNames().get(i))).get("pins")).get(0));




        mainActivity.uebergabe.read(deviceName,
                new Response.Listener<JSONObject>() {
            @Override
            public void onResponse(final JSONObject response) {
                if (favoriteMode == 0){
                    deviceName = mainActivity.xml.getDeviceNames().get(i);
                }else{
                    deviceName = mainActivity.favorite.getFavorites().get(i);
                }
                try {
                    JSONObject state = response.getJSONObject("state");
                    List<String> pinValues = new ArrayList<>();
                    for(String pinName: ((List<String>)mainActivity.xml.
                            getPort(deviceName).
                            get("pins"))){
                        pinValues.add(state.getString(pinName));
                    }
                    PinView pinView = new PinView(mainActivity,deviceName, pinValues);
                    for(int j = 0; j < ((List<String>)mainActivity.xml.
                            getPort(deviceName).
                            get("pins")).size(); j++) {
                        linearLayoutPin.addView(pinView.getView(j));
                    }
                } catch (JSONException e) {
                                                                // Richtigen log erstellen
                    e.printStackTrace();
                }

            }
        });




        textViewName.setText(deviceName);
        buttonViewFavoriten.setImageResource(favoriteImage);
        return view;
    }
}
